
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java 理论与实践: 良好的内务处理实践 / iVAN</title>

    <meta name="description" content="Java 理论与实践: 良好的内务处理实践 垃圾收集几乎是每个开发人员都喜爱的一个 Java 平台特性,它简化了开发,消除了所有种类的潜在代码错误.可尽管垃圾收集一般来说可以让您无需进行资源管理,有时候您还是必须自己进行一些内务处理.在本文中,Brian Goetz 讨论了垃圾收集的局限性,并指出了您必须自己做内务处理的场景. 小时候,父母总是叮嘱我们玩了玩具之后要收好.如果您仔细想想,其实这种唠叨并不过分,要保持整洁是因为存在实际的限制,房间里没有太多的空间,如果到处堆满了玩具,那么连走路都无处下脚了. 如果有了足够的空间,保持整洁就不">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java 理论与实践: 良好的内务处理实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　　垃圾收集几乎是每个开发人员都喜爱的一个 Java 平台特性，它简化了开发，消除了所有种类的潜在代码错误。可尽管垃圾收集一般来说可以让您无需进行资源管理，有时候您还是必须自己进行一些内务处理。在本文中，Brian Goetz 讨论了垃圾收集的局限性，并指出了您必须自己做内务处理的场景。</p>
<p>　　小时候，父母总是叮嘱我们玩了玩具之后要收好。如果您仔细想想，其实这种唠叨并不过分，要保持整洁是因为存在实际的限制，房间里没有太多的空间，如果到处堆满了玩具，那么连走路都无处下脚了。</p>
<p>　　如果有了足够的空间，保持整洁就不是那么必要了。空间越多，就越不必要保持整洁。Arlo Guthrie 著名的民谣 Alice's Restaurant Massacre 说明了这一点：</p>
<p>　　他们住在教堂楼下的大厅，里面的椅子全都搬走了，剩下一个空荡荡的大房间，所以他们想，很长时间都不用把垃圾扔出去，有的是地方装垃圾……</p>
<p>　　无论如何，垃圾收集可以帮我们减轻内务整理方面的工作。</p>
<p>　　<b>显式地释放资源</b></p>
<p>　　Java 程序中使用的绝大多数资源都是对象，垃圾收集在清理对象方面做得很好。因此，您可以使用任意多的 String。垃圾收集器最终无需您的干预就会算出它们何时失效，并收回它们使用的内存。</p>
<p>　　另一方面，像文件句柄和套接字句柄这类非内存资源必须由程序显式地释放，比如使用 close()、destroy()、shutdown() 或 release() 这样的方法来释放。有些类，比如平台类库中的文件句柄流实现，提供终结器（finalizer）作为安全保证，以便当垃圾收集器确定程序不再使用资源而程序却忘了释放资源时，终结器还可以来做这个释放工作。但是尽管文件句柄提供了终结器来在您忘记了时为您释放资源，最好还是在使用完之后显式地释放资源。这样做可以更早地释放资源，降低了资源耗尽的可能。</p>
<p>　　对于有些资源来说，一直等到终结（finalization）释放它们是不可取的。对于重要的资源，比如锁获取和信号量许可证，Lock 或 Semaphore 直到很晚都可能不会被垃圾收集掉。对于数据库连接这样的资源，如果您等待终结，那么肯定会消耗完资源。许多数据库服务器根据许可的容量，只接受一定数量的连接。如果服务器应用程序为每个请求都打开一个新的数据库连接，然后用完之后就不管了，那么数据库远远未到终结器关闭不再需要的连接，就会到达它的最高容量。</p>
<p>　　<b>只限于一个方法的资源</b></p>
<p>　　多数资源都不会持续整个应用程序的生命周期，相反，它们只被用于一个活动的生命周期。当应用程序打开一个文件句柄读取文件以处理文档时，它通常读取文件后就不再需要文件句柄了。</p>
<p>　　在最简单的情况下，资源在同一个方法调用中被获取、使用和释放，比如清单 1 中的 loadPropertiesBadly() 方法：</p>
<p>　　清单 1. 不正确地在一个方法中获取、使用和释放资源 —— 不要这样做</p>
<p>public static Properties loadPropertiesBadly(String fileName)<br />throws IOException {<br />　FileInputStream stream = new FileInputStream(fileName);<br />　Properties props = new Properties();<br />　props.load(stream);<br />　stream.close();<br />　return props;<br />} <br />　　不幸的是，这个例子存在潜在的资源泄漏。如果一切进展顺利，流将会在方法返回之前被关闭。但是如果 props.load() 方法抛出一个 IOException，那么流则不会被关闭（直到垃圾收集器运行其终结器）。解决方案是使用 try...finally 机制来确保流被关闭，而不管是否发生错误，如清单 2 所示：</p>
<p>　　清单 2. 正确地在一个方法中获取、使用和释放资源</p>
<p>public static Properties loadProperties(String fileName) <br />throws IOException {<br />　FileInputStream stream = new FileInputStream(fileName);<br />　try {<br />　　Properties props = new Properties();<br />　　props.load(stream);<br />　　return props;<br />　}<br />　finally {<br />　　stream.close();<br />　}<br />} <br />　　注意，资源获取（打开文件）是在 try 块外面进行的；如果把它放在 try 块中，那么即使资源获取抛出异常，finally 块也会运行。不仅该方法会不适当（您无法释放您没有获取的资源），finally 块中的代码也可能抛出其自己的异常，比如 NullPointerException。从 finally 块抛出的异常取代导致块退出的异常，这意味着原来的异常丢失了，不能用于帮助进行调试。 并不总像看起来那么容易</p>
<p>　　使用 finally 来释放在方法中获取的资源是可靠的，但是当涉及多个资源时，很容易变得难以处理。下面考虑这样一个方法，它使用一个 JDBC Connection 来执行查询和迭代 ResultSet。该方法获得一个 Connection，使用它来创建一个 Statement，并执行 Statement 以得到一个 ResultSet。但是中间 JDBC 对象 Statement 和 ResultSet 具有它们自己的 close() 方法，并且当您使用完之后，应该释放这些中间对象。然而，进行资源释放的 “明显的” 方式并不起作用，如清单 3 所示：</p>
<p>　　清单 3. 不成功的释放多个资源的企图 —— 不要这样做</p>
<p>public void enumerateFoo() throws SQLException {<br />　Statement statement = null;<br />　ResultSet resultSet = null;<br />　Connection connection = getConnection();<br />　try {<br />　　statement = connection.createStatement();<br />　　resultSet = statement.executeQuery("SELECT * FROM Foo");<br />　　// Use resultSet<br />　}<br />　finally {<br />　　if (resultSet != null)<br />　　　resultSet.close();<br />　　if (statement != null)<br />　　　statement.close();<br />　　connection.close();<br />　}<br />} <br />　　这个 “解决方案” 不成功的原因在于，ResultSet 和 Statement 的 close() 方法自己可以抛出 SQLException，这会导致后面 finally 块中的 close() 语句不执行。您在这里有几种选择，每一种都很烦人：用一个 try..catch 块封装每一个 close()，像清单 4 那样嵌套 try...finally 块，或者编写某种小型框架用于管理资源获取和释放。</p>
<p>　　清单 4. 可靠的释放多个资源的方法</p>
<p>public void enumerateBar() throws SQLException {<br />　Statement statement = null;<br />　ResultSet resultSet = null;<br />　Connection connection = getConnection();<br />　try {<br />　　statement = connection.createStatement();<br />　　resultSet = statement.executeQuery("SELECT * FROM Bar");<br />　　// Use resultSet<br />　}<br />　finally {<br />　　try {<br />　　　if (resultSet != null)<br />　　　　resultSet.close();<br />　　}<br />　　finally {<br />　　　try {<br />　　　　if (statement != null)<br />　　　　　statement.close();<br />　　　}<br />　　　finally {<br />　　　　connection.close();<br />　　　}<br />　　}<br />　}<br />}</p>
<p>private Connection getConnection() {<br />　return null;<br />} <br />　　几乎每一样东西都可以抛出异常</p>
<p>　　我们都知道应该使用 finally 来释放像数据库连接这样的重量级对象，但是我们并不总是这样细心，能够记得使用它来关闭流（毕竟，终结器会为我们做这件事，是不是？）。很容易忘记在使用资源的代码不抛出已检查的异常时使用 finally。清单 5 展示了针对绑定连接的 add() 方法的实现，它使用 Semaphore 来实施绑定，并有效地允许客户机等待空间可用：</p>
<p>　　清单 5. 绑定连接的脆弱实现 —— 不要这样做</p>
<p>public class LeakyBoundedSet&lt;T&gt; {<br />　private final Set&lt;T&gt; set = ...<br />　private final Semaphore sem;</p>
<p>　public LeakyBoundedSet(int bound) {<br />　　sem = new Semaphore(bound);<br />　}</p>
<p>　public boolean add(T o) throws InterruptedException {<br />　　sem.acquire();<br />　　boolean wasAdded = set.add(o);<br />　　if (!wasAdded)<br />　　　sem.release();<br />　　return wasAdded;<br />　}<br />} <br />　　LeakyBoundedSet 首先等待一个许可证成为可用的（表示连接中有空间了），然后试图将元素添加到连接中。添加操作如果由于该元素已经在连接中了而失败，那么它会释放许可证（因为它不实际使用它所保留的空间）。</p>
<p>　　与 LeakyBoundedSet 有关的问题没有必要马上跳出：如果 Set.add() 抛出一个异常呢？如果 Set 实现中有缺陷，或者 equals() 或 hashCode() 实现（在 SortedSet 的情况下是 compareTo() 实现）中有缺陷，原因在于添加元素时元素已经在 Set 中了。当然，解决方案是使用 finally 来释放信号量许可证，这是一个很简单却容易被遗忘的方法。这些类型的错误很少会在测试期间暴露出来，因而成了定时炸弹，随时可能爆炸。清单 6 展示了 BoundedSet 的一个更加可靠的实现：</p>
<p>　　清单 6. 使用一个 Semaphore 来可靠地绑定 Set</p>
<p>public class BoundedSet&lt;T&gt; {<br />　private final Set&lt;T&gt; set = ...<br />　private final Semaphore sem;</p>
<p>　public BoundedHashSet(int bound) {<br />　　sem = new Semaphore(bound);<br />　}</p>
<p>　public boolean add(T o) throws InterruptedException {<br />　　sem.acquire();<br />　　boolean wasAdded = false;<br />　　try {<br />　　　wasAdded = set.add(o);<br />　　　return wasAdded;<br />　　}<br />　　finally {<br />　　　if (!wasAdded)<br />　　　　sem.release();<br />　　}<br />　}<br />} <br />　　像 FindBugs这样的代码审查工具可以检测出不适当的资源释放的一些实例，比如在一个方法中打开一个流却不关闭它。</p>
<p>　　<b>具有任意生命周期的资源</b></p>
<p>　　对于具有任意生命周期的资源，我们要回到 C 语言的时代，即手动地管理资源生命周期。在一个服务器应用程序中，客户机到服务器的一个持久网络连接存在于一个会话期间（比如一个多人参与的游戏服务器），每个用户的资源（包括套接字连接）在用户退出时必须被释放。好的组织是有帮助的；如果对每个用户资源的角色引用保存在一个 ActiveUser 对象中，那么它们就可以在 ActiveUser 被释放时（无论是显式地释放，还是通过垃圾收集而释放）而被释放。</p>
<p>　　具有任意生命周期的资源几乎总是存储在一个全局集合中（或者从这里可达）。要避免资源泄漏，因此非常重要的是，要识别出资源何时不再需要了并可以从这个全局集合中删除了。（以前的一篇文章 “用弱引用堵住内存泄漏” 给出了一些有用的技巧。）此时，因为您知道资源将要被释放，任何与该资源关联的非内存资源也可以同时被释放。</p>
<p>　　<b>资源所有权</b></p>
<p>　　确保及时的资源释放的一个关键技巧是维护所有权的一个严格层次结构，其中的所有权具有释放资源的职责。如果应用程序创建一个线程池，而线程池创建线程，线程是程序可以退出之前必须被释放的资源。但是应用程序不拥有线程，而是由线程池拥有线程，因此线程池必须负责释放线程。当然，直到它本身被应用程序释放之后，线程池才能释放线程。</p>
<p>　　维护一个所有权层次结构有助于不至于失去控制，其中每个资源拥有它获得的资源并负责释放它们。这个规则的结果是，每个不能由垃圾收集单独收集的资源（即这样的资源，它直接或间接拥有不能由垃圾收集释放的资源）必须提供某种生命周期支持，比如 close() 方法。</p>
<p>　　<b>终结器</b></p>
<p>　　如果说平台库提供终结器来清除打开的文件句柄，这大大降低了忘记显式地关闭这些句柄的风险，为什么不更多地使用终结器呢？原因有很多，最重要的一个原因是，终结器很难正确编写（并且很容易编写错）。终结器不仅难以编写正确，终结的定时也是不确定的，并且不能保证终结器最终会运行。并且终结还为可终结对象的实例化和垃圾收集带来了开销。不要依赖于终结器作为释放资源的主要方式。</p>
<p>　　<b>结束语</b></p>
<p>　　垃圾收集为我们做了大量可怕的资源清除工作，但是有些资源仍然需要显式的释放，比如文件句柄、套接字句柄、线程、数据库连接和信号量许可证。当资源的生命周期被绑定到特定调用帧的生命周期时，我们通常可以使用 finally 块来释放该资源，但是长期存活的资源需要一种策略来确保它们最终被释放。对于任何一个这样的对象，即它直接或间接拥有一个需要显式释放的对象，您必须提供生命周期方法 —— 比如 close()、release()、destroy() 等 —— 来确保可靠的清除。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 10:23:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e8%b5%84%e6%ba%90/" title="资源">资源</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/findbugs/" title="findbugs">findbugs</a>, <a href="https://www.iamivan.net/tag/%e5%8f%a5%e6%9f%84/" title="句柄">句柄</a>, <a href="https://www.iamivan.net/tag/%e9%87%8a%e6%94%be/" title="释放">释放</a>, <a href="https://www.iamivan.net/tag/finally/" title="finally">finally</a>, <a href="https://www.iamivan.net/tag/%e9%87%8a%e6%94%be%e8%b5%84%e6%ba%90/" title="释放资源">释放资源</a>, <a href="https://www.iamivan.net/tag/%e8%b5%84%e6%ba%90%e9%87%8a%e6%94%be/" title="资源释放">资源释放</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9e%e6%8e%a5oracle%e6%8a%9b%e5%bc%82%e5%b8%b8-o/" title="连接oracle抛异常 o">连接oracle抛异常 o</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java 理论与实践: 良好的内务处理实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqNYRp.html" rel="bookmark">Java 理论与实践：变还是不变？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不变对象具有许多能更方便地使用它们的特性,包括不严格的同步需求和不必考虑数据讹误就能自由地共享和高速缓存对象引用.尽管不变性可能未必对于所有类都有意义,但大多数程序中至少有一些类将受益于不可变.在本月的 Java 理论与实践中,Brian Goetz 说明了不变性的一些长处和构造不变类的一些准则.请在附带的论坛中与作者和其他读者分享您关于本文的心得.(也可以单击文章顶部或底部的&quot;讨论&quot;来访问论坛.) 不变对象是指在实例化后其外部可见状态无法更改的对象.Java 类库中的 String.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOoE9z.html" rel="bookmark">Java 理论与实践&colon; JDK 5&period;0 中更灵活、更具可伸缩性的锁定机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				伸缩 内容: synchronized 快速回顾 对 synchronized 的改进 比较 ReentrantLock 和 synchronized 的可伸缩性 条件变量 这不公平 结束语 参考资料 关于作者 对本文的评价 相关内容: Java 理论与实践 系列 Synchronization is not the enemy Reducing contention IBM developer kits for the Java platform (downloads) 订阅: develop			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNm9Zb.html" rel="bookmark">Java理论与实践&colon; 您的小数点到哪里去了？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				许多程序员在其整个开发生涯中都不曾使用定点或浮点数,可能的例外是, 偶尔在计时测试或基准测试程序中会用到.Java语言和类库支持两类非整数类型 ― IEEE 754 浮点( float 和 double ,包装类(wrapper class)为 Float 和 Double ),以及任意精度的小数( java.math.BigDecimal ).在本月的 Java 理论和实践中,Brian Goetz 探讨了在 Java 程序中使用非整数类型时一 些常碰到的陷阱和&quot;gotcha&quot;. 虽			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4jG9p.html" rel="bookmark">Java理论与实践&colon; 垃圾收集简史</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 语言可能是使用最广泛的依赖于垃圾收集的编程语言,但是它并不是第 一个.垃圾收集已经成为了包括 Lisp.Smalltalk.Eiffel.Haskell.ML. Scheme和 Modula-3 在内的许多编程语言的一个集成部分,并且从 20 世纪 60 年代早期就开始使用了.在 Java 理论与实践的本篇文章中,Brian Goetz 描述 了垃圾收集最常用的技术. 垃圾收集的好处是无可争辩的 ―― 可靠性提高.使内存管理与类接口设计 分离,并使开发者减少了跟踪内存管理错误的时间.著			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj753WM.html" rel="bookmark">Java理论与实践&colon; 构建一个更好的HashMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ConcurrentHashMap 是 Doug Lea的 util.concurrent 包的一部分,它提供 比Hashtable 或者 synchronizedMap 更高程度的并发性.而且,对于大多数成 功的 get() 操作它会设法避免完全锁定,其结果就是使得并发应用程序有着非 常好的吞吐量.这个月,BrianGoetz 仔细分析了 ConcurrentHashMap的代码, 并探讨 Doug Lea 是如何在不损失线程安全的情况下取得这么骄人成绩的. 在7月份的那期 Java理论与实践			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAajWXM.html" rel="bookmark">Java理论与实践&colon; 消除bug</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多有关编程风格的建议都是为了创建高质量.可维护的代码,这很合理, 因为最容易修复 bug 的时间就是在产生 bug 之前(少量的预防措施--).遗 憾的是,只预防往往是不够的,虽然有一些精巧的工具可以帮助您创建好的代码 ,但是很少有工具可以帮助您分析.维护或提高现有代码的质量. 写线程安全的类很难,而分析现有类的线程安全性更难,增强类使其仍然保 持线程安全也很难.以隐含假定.不变式以及预期用例(虽然在开发人员的头脑 中很清晰,但是没有以设计笔记.注释或者文档的方式记录下来)的方式编写完 类之后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bElRBAz.html" rel="bookmark">Java理论与实践&colon; 修复Java内存模型，第1部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				活跃了将近三年的 JSR 133,近期发布了关于如何修复 Java 内存模型 (Java Memory Model, JMM)的公开建议.原始 JMM 中有几个严重缺陷,这导 致了一些难度高得惊人的概念语义,这些概念原来被认为很简单,如 volatile .final 以及 synchronized.在这一期的 Java 理论与实践 中,Brian Goetz 展示了如何加强 volatile 和 final 的语义,以修复 JMM.这些更改有些已经 集成在 JDK 1.4 中:而另一些将会包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxEvob.html" rel="bookmark">Java理论与实践&colon;做个好的（事件）侦听器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				观察者模式在 Swing 开发中很常见,在 GUI 应用程序以外的场景中,它对 于消除组件的耦合性也非常有用.但是,仍然存在一些侦听器登记和调用方面的 常见缺陷.在 Java 理论与实践 的这一期中,Java 专家 Brian Goetz 就如何 做一个好的侦听器,以及如何对您的侦听器也友好,提供了一些感觉很好的建议 .请在相应的 讨论论坛 上与作者和其他读者分享您对这篇文章的想法.(您也 可以单击本文顶部或底部的 讨论 访问论坛.) Swing 框架以事件侦听器的形式广泛利用了观察者模式(也称			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wPaLp.html" rel="bookmark">Java理论与实践专题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java理论与实践: JDK 5.0中更灵活.更具可伸缩性的锁定机制 Java理论和实践: 一个有缺陷的微基准的剖析 Java理论和实践: 理解JTS ― 平衡安全性和性能 Java理论和实践: 理解JTS ― 幕后魔术 Java理论和实践: 安全构造技术 Java理论与实践: 平衡测试,第3部分:用方面检验设计约束 Java理论与实践:平衡测试,第2部分:编写和优化bug检测器 Java理论与实践:平衡测试,第1部分:不要仅编写测试,还要编写bu Java理论与实践: 您的小数点到哪里去了?			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLnaLb.html" rel="bookmark" class="title">Flash视频教程实例：风吹字体效果</a>
					<div>
						教程|视频教程 制作步骤:(全屏观看教程)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrnAyM.html" rel="bookmark" class="title">支持oicq头像的留言簿&lpar;二&rpar;</a>
					<div>
						addnote.php &lt;HTML&gt; &lt;HEAD&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;tex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyQO5M.html" rel="bookmark" class="title">C&num;类型转换专题</a>
					<div>
						转换 1. 装箱.拆箱还是别名 许多 C#.NET 的书上都有介绍 int -&gt; Int32 是一个装箱的过程,反之则是拆箱的过程.许多其它变量类型也是如此,如:short &lt;-&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOeeRM.html" rel="bookmark" class="title">新手SEO浅谈影响排名的七大用户行为</a>
					<div>
						除了网站结构优化.页面优化和外部链接影响排名以外,还有一个影响排名的因素那就是用户行为.所有的网站的实用性都取决于用户行为,下面我来简单说下用户那些行为可以影响排名. 1.网站流量和Alexa排名.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmJKjz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;百度seo建议&rdquo;之后给我们的seo教育</a>
					<div>
						    这次百度官方发布的&quot;百度seo建议&quot;狠狠地给我们站长上了一课,也是我们seoer新的一个征程.百度这次更新的目的就是为了提高更好的用户体验和防止站长朋友的作弊手段.搜索引擎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMylxJb.html" rel="bookmark" class="title">Ext中namespace的作用</a>
					<div>
						Ext中在每一个页面中添加一个namespace呢,就像下面的代码: // create namespace Ext.namespace('myNameSpace'); // create appli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNBq8b.html" rel="bookmark" class="title">Windows 2003活动目录管理之如何修复遭损害的电脑账号</a>
					<div>
						在多数情况下,客户机的域帐号具有自我修复能力.但有时,尤其是在非常大的域网络里,帐号不能与域连接或不能正常运行.这使得某个客户机不能以有效的域的客户帐号登录到域. 如果你怀疑客户机帐号丢失,损坏或不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKmVap.html" rel="bookmark" class="title">简述AIX的备份和恢复</a>
					<div>
						在这章的例子中使用了一个 5GB 8-mm 磁带驱动器,其设备文件为/dev/rmt0. 一.备份 备份可以通过命令行或 SMIT 菜单实现. 1.命令行备份 AIX命令 backup 和 resto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M627wAM.html" rel="bookmark" class="title">ASP&period;NET获取MS SQL Server安装实例</a>
					<div>
						View Code protected void Page_Load(object sender, EventArgs e) { DataTable dataTable = SqlDataSource ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaORkz.html" rel="bookmark" class="title">实现jquery定时器的简单代码</a>
					<div>
						 项目遇到一个消息的模块,在导航条最上面.想实现,当收到消息的时候能够及时的刷新,显示收到消息的条数,下面为大家介绍两种不错的方法,感兴趣的朋友可以参考下 简单的代码实现jquery定时器.    今 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ82vp.html" rel="bookmark" class="title">如何设置Win8不同版本的背景图片</a>
					<div>
						  在Windows8开发者预览版中 ,metro菜单背景图片是以PNG格式储存在shsxs.dll这个文件中的,官方并没有告诉我们如何自定义背景.在Windows 8 Pre-beta版本中shsx ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ew6Ab.html" rel="bookmark" class="title">参观车展归来 巧用后期获得个性好照片</a>
					<div>
						车展,意味着豪车美女.精彩表演等各种吸引眼球的元素都被揉合在一起呈现.以&quot;绿色科技驾驭成都&quot;为主题的第十五届成都国际车展在成都世纪城新国际会展中心举行,爱好摄影的你一定不会错过这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGyyAp.html" rel="bookmark" class="title">06&period;移动先行之谁主沉浮----我的代码我来写（Xaml的优势）</a>
					<div>
						如果移动方向有任何问题请参考===&gt; 异常处理汇总-移动系列(点) 前面几节课,我们都是在前台创建对象,进行一些设置,那么我们为什么不用传统的方法来编程呢? 我们今天来试试你就明了了~~   打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBJnDz.html" rel="bookmark" class="title">一个AJAX类代码&lowbar;AJAX相关</a>
					<div>
						基本用法: 复制代码 代码如下: var ajax = new AjaxObj(url); ajax.addListener(200, function(r){ alert(r); }); ajax. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA77vnz.html" rel="bookmark" class="title">一堆吸引屎壳郎的屎</a>
					<div>
						问题描述 CSDN的真实写照:如题 解决方案 解决方案二:那楼主的帖子是啥?嘿嘿解决方案三:注意素质!!!解决方案四:QQ群:323373解决方案五:楼主就是那堆屎解决方案六:引用4楼yuwenge的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA71wnz.html" rel="bookmark" class="title">grails数据同步问题？</a>
					<div>
						问题描述 grails数据同步问题? 5C grails框架怎么将redis数据同步到mysql里面???					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq093b.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;刷手机&rdquo;时代悄然来临 手机支付呼唤国家标准</a>
					<div>
						中国建设银行28日正式宣布将移动支付业务推向包括北京.宁波在内的11家试点分行,除了缴费.订票.在线购物等远程支付外,客户只需要将手机轻轻接触一下POS机,就可以在商场.超市&quot;刷手机&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNj9mPM.html" rel="bookmark" class="title">php按百分比生成缩略图的代码分享&lowbar;php实例</a>
					<div>
						于是翻了一下手册,弄懂几个函数后自己写了一个简单的php生成缩略图的程序.没有用类,我觉得一个函数就能搞定,而且对于新手来说更容易去理解,从而可以帮助到更多的人. 支持按比分比缩略,支持按指定的长宽缩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1rYJz.html" rel="bookmark" class="title">求助：把 web 项目建成 library后&comma;提示未能找到程序集（附件可下载）</a>
					<div>
						问题描述 请问各位大虾,Web项目,如何可以像CommunityServer那样,把Web项目建立成Library的项目.我建完后,在Default.aspx里加载程序集:&lt;%@Register ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKjq2z.html" rel="bookmark" class="title">正则表达式a&period;&ast;&quest;b的疑问</a>
					<div>
						问题描述 ,iid_code=icode='B3MvydqABZg',oid=58086936我要从上面的源中取出B3MvydqABZg,现在我的写法是icode='(.*?)'得出的结果是icode ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE43oZz.html" rel="bookmark" class="title">5G超密集组网驱动光模块市场爆发</a>
					<div>
						移动通信是光网络发展的重要驱动力,对于光模块市场发展的重要性也不言而喻.我们知道,光模块市场可细分为电信(Telecom)市场.数通(Datacom)市场和接入(Access)市场.从2016年全年的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq72dRz.html" rel="bookmark" class="title">分布式消息系统jafka快速起步（转）</a>
					<div>
						Jafka 是一个开源的/性能良好的分布式消息系统.在上一篇文章中有所简单介绍.下面是一篇简单的入门文档.更多详细的文档参考wiki. Step 1: 下载最新的安装包 完整的安装指南在这里.最新的发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7L7az.html" rel="bookmark" class="title">微信公众号运营3天从2000人飙升到10万人的秘密（干货图）</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 关于微信营销,大家都很关注,今天我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7x28Rb.html" rel="bookmark" class="title">国内三大云数据库测试对比</a>
					<div>
						我司 CTO 和技术总监都是腾讯系的,所以我们一开始就选用腾讯云的服务.他们家的云数据库提供了可视化的运维操作页面和自动备份的能力,降低了数据库运维的门槛.同时云数据库还支持高可用架构,对数据的安全性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnQKBM.html" rel="bookmark" class="title">媒体人转型装逼指南：要么高调，要么低调，总有一款适合</a>
					<div>
						对经历过行业风光的媒体人来说,转型现在是时髦的选择.仿佛一转型,过去记者编辑生涯的积累就都能套现,而且接下来会有远大灿烂未来.但http://www.aliyun.com/zixun/aggregat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5R9YBz.html" rel="bookmark" class="title">男子第一份工资买小米3 问题不断&OpenCurlyDoubleQuote;偶像破灭&rdquo;</a>
					<div>
						换了一次新机,水波纹问题依旧明显 上周,本报详细报道了&lt;难抢的小米:饥饿营销与虚假抢购悬疑&gt;,在各大论坛和媒体.用户中引起了较大反响,那么对于有幸抢购到手机的米粉而言,体验是否如小米3宣传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YBrZz.html" rel="bookmark" class="title">马云IPO现场言论：偶像是阿甘，对挣钱不感兴趣</a>
					<div>
						摘要: 毫无疑问,今天所有的互联网人都在关注着纽交所的.走过15年风雨的中国电子商务巨头迎来IPO,他们将以68美元的发行价募集210到260亿美元资金.马云和阿里巴巴的主要管理团队出现在 毫无疑问, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL3mnM.html" rel="bookmark" class="title">《企业级ios应用开发实战》一1&period;2 iOS企业应用程序的架构</a>
					<div>
						1.2 iOS企业应用程序的架构 本书把iOS企业应用定义为传统企业应用向iOS手机终端的顺延和扩张.在此定义下,iOS企业应用由服务端和iOS客户端构成,二者间通过3G移动互联网(CDMA/TD/W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQegkp.html" rel="bookmark" class="title">阿里多位技术专家参加ACM图灵奖50周年大会，增进产学研互动</a>
					<div>
						近日,ACM图灵奖五十年中国大会(ACM TURC 2017)在上海举行,图灵奖得主文顿·瑟夫.约翰·霍普克洛夫特.姚期智和中科院院士陈润生.中国工程院院士.北京大学教授高文等在内的众多国内外学者参会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeRX8M.html" rel="bookmark" class="title">《数据库技术原理与应用教程》一2-1数据库中的基本概念</a>
					<div>
						2-1数据库中的基本概念 1 数据 (1)数据的概念 数据(data)是现实世界中客体在计算机中的抽象表示.具体地说,它是一种计算机内的有限个数的一组符号表示. 由于数据是一种抽象的符号表示,因此它缺 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
